# Morphling

*Cause nobody aint got time to wait for back-ends to be developped.*

## Features

- A sweet all-in-CLI with **no knowledge of Javascript necessary** (if you can write JSON you're good 👍 )
- **Mocks any object, array or field** declared in a swagger with meaningful **autogenerated data**
- **Persists routes mocks** to allow you to develop your front-end as fast as a lightning
- Two lines install and **minimal knowledge of backend necessary**
- Supports **JSON and YAML** swaggers
- Supports (a big part of) **OpenAPI 3.0**

## Installation from source

Ensure that you have both `docker` and `docker-compose` installed and available to your terminal.

- Clone the package
- Inside the package: `make start` and wait for the build to be over
- If the message `Morphling started on 8883` pops, it means that everything went well!
- `npm link` to make `morphling` available globally to your terminal
- `morphling config` and go through the short process
- `morphling --help` for other informations should help you out.

*Note: If having any issues during the install with npm such as 'Cannot read property 0 of undefined', 
try to downgrade your current npm install to 5.2.0* 

## Usage

`morphling start` if your Morphling is not already running.

Add a swagger.yml file to Morphling by doing a `morphling apply your/file`

Now morphling knows your swagger and can mock it properly. 
Just try to hit a route that is described in your swagger !

To see what swaggers Morphling knows do a `morphling list`.

 
## Useful development commands

I've made available a `morphling bash` command which immediately bashes you inside the currently-running Docker 
instance of morphling

`make `

- `start` Run the build proces and start the morphling docker instance immediatly then pipe the logs
- `dev` Start the server without docker on a bare Nodejs process
- `build` Build all javascript files with *Babel*.
- `docker-build` Run the docker build process and run the server.
- `clear-docker` Hard-delete the morphling instance from your local Docker
- `devstart-hard` Clear all dependencies and docker morphling instances and start

## Upcoming features

- Print morphlingjs version with `--version / -v`
- On the go switching of running ports
- Add ID to overrides and swagger so you dont have to type them down
- `morphling validate` A proper validator for the swagger files and an associated CLI command
- `morphling remove` Remove a file from morphling
- `morphling remove-all` Remove all files from morphling (also remove local saves of fixtures) always with --force
- A better autocompletion using the npm package `commander-completion`
- Overriding a field key in an object with a specific faker generator (ie: zipcode, username...)
- Override checker (ensure that a specific override does not already exist when adding another one)
